SystemOrganization addCategory: #'SCouchDB-JQuery-Tests'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Tests-Functional'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Tests-Functional-mobile'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Tests-Functional-mobile2'!

MuSTemplate subclass: #MuSAlbumDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

!MuSAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 02:06'!
initialize
super initialize.
self fullDocument:true.! !

!MuSAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/11/2013 12:17'!
renderAlbumRemoveScriptOn:html
| aScript |

"we need the _revision"
aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: '_id' put:((html jQuery:#dataStorage) dataAt:#currentDoc);
	at: '_rev' put:((html jQuery:#dataStorage) dataAt:#currentRev);yourself
)). 
	

^
aScript,
(html jQuery couch db:'albums';removeDoc: (JSStream on:'doc');
					onSuccess:(html jQuery mobile changePageUrl:  '/albums/_design/musalbums/_list/albumIndex/albums' options:nil);
					onError:(( html jQuery:#fHeader) text:'Error deleting a Doc')
)! !

!MuSAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 02:11'!
renderContentOn: html
html div 
	attributeAt:'data-role' put:'dialog'; 
	id:'albumDelete';
	with:[
		html div jqmHeader;
      		with: [
         		html heading
            		level1;
				id:#fHeader;
            		with: 'Delete Album'].
 		 html div jqmContent;
      	with: [
			html heading level3 with:'Are you sure you want to remove this album?'].
		
		html div jqmFooter;
		jqmFixedPosition;	
      	with: [
			html div
				jqmNavBar;
				with: [
					html unorderedList: [
						html listItem: [
							html anchor
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							onClick:(self renderAlbumRemoveScriptOn:html);
							with: 'Ok' 
							] 
						] 
					]
			]	
	
]! !

MuSTemplate subclass: #MuSAlbumEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

MuSAlbumEditor subclass: #MuSAlbumAttachmentsEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

!MuSAlbumAttachmentsEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 09:35'!
renderContentOn: html
	html form id:#saveAttachmentForm;post;action:nil;multipart;with:[  
						html fileUpload id:#_attachments;name:#_attachments;multiple.  
						html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev').
				].
	html paragraph: 'Attachments:'.
	html mustache section 
		name:'attachmentsList';
		with:[
			html image
				url: '/albums/',(html mustache variable:'_id') , 
					'/',
					(html mustache variable:'filename').
			html break.
			html anchor jqmButton;class:'del';
			with:'remove'.	
		].! !

!MuSAlbumAttachmentsEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 19:46'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

!MuSAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 09:23'!
renderContentOn: html

html div 
	jqmPage; 
	id:#albumEditorPage;
	attributeAt:'data-add-back-btn' put:'true';
	with:[

		html div jqmHeader;with:[
			html heading level1;id:#eHeader;with:'Album Editor'.
			html anchor url:'#home';jqmIcon:#grid;with:'Home'.  
		].
		html div jqmContent;
			id:#albumAdd;	
			with:[
				html div jqmContainerTwoColumn; with: [
				html div jqmColumnOne; with: [
				html form id:#saveForm;post;with:[				
				self renderFormElementOn:html element:[
				html label
					for:#artist;
					with:'Artist:'.
				html textInput id:#artist;name:#artist;value:(html mustache variable:'artist').
				].
				self renderFormElementOn:html element:[
				html label
					for:#title;
					with:'Title:'.
				html textInput id:#title;name:#title;value:(html mustache variable:'title')].
				self renderFormElementOn:html element:[
				html label
					for:#description;
					with:'Description:'.
				html textInput id:#description;name:#description;value:(html mustache variable:'description')].
				
				html hiddenInput id:#user;name:#user;value: (html mustache variable:'user').
				html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev').
				html hiddenInput id:#id;name:#_id;value: (html mustache variable:'_id').
					]
				].
				html div jqmColumnTwo; with: [html mustache partial:#MuSAlbumAttachmentsEditor].
				
				 html mustache section name:'_attachments';inverted;with:[html script: ('attachments={}')].
				 html mustache section name:'_attachments';with:[
					html script: ('attachments=', (html mustache unescapedVariable:'renderedAttachments'))].
			]
		].
		
		html div jqmFooter;jqmFixedPosition;with:[
			html div id:#albumFooter;jqmNavBar;with:[ 
				html unorderedList:[ 
					html listItem:[html anchor id:#addCancelButton;
						jqmIcon:#minus;
						onClick:((JSStream on:'history') call:'back');
						with: 'Cancel' ].
					html listItem: [html anchor id:#saveButton;
						jqmIcon:#gear;
						with:'Save']		 		
				]  
			]
		].
	] .

! !

!MuSAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/8/2013 12:58'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

MuSTemplate subclass: #MuSAlbumView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

!MuSAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 10:44'!
renderContentOn: html
html div 
	jqmPage; 
	id:#albumViewPage;
	attributeAt:'data-add-back-btn' put:'true';
	with:[
		html div jqmHeader;with:[
			html heading level1;with:(html mustache variable:'title').
			html anchor id:'deleteCloseButton';url:'#home';jqmIcon:#grid;with:'Home'.  
		].
		html div jqmContent;
			id:'albumcontent';
			class:'command-no-cache';
			attributeAt:'data-identity' put: (html mustache variable:'document');
			with:[
				html div jqmContainerTwoColumn; with: [
				html div jqmColumnOne; with: [
				html heading level2;class:'artist';with:(html mustache variable:'artist').
				html paragraph class:'title';with:(html mustache variable:'title').
				html paragraph class:'description';with:(html mustache variable:'description').
				html paragraph class:'owner';with:(html mustache variable:'user').
				"store rev and id, we'll update dataStorage on pagebeforecreate event
				we need that when we come back from the Editor"
				html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev').
				html hiddenInput id:#id;name:#_id;value: (html mustache variable:'_id').
				].
				html div jqmColumnTwo; with: [html mustache partial:#MusAlbumAttachments]
			]
			
			].
		html div jqmFooter;jqmFixedPosition;with:[
			html div id:#albumFooter;jqmNavBar;with:[ 
				html unorderedList:[ 
					html listItem: [html anchor id:'editButton';
						jqmIcon:#gear;
						with:'Edit'].
					html listItem:[html anchor id:'deleteButton';
						jqmIcon:#minus;
						with:'Delete'].  
					
					]  
			]
		]
	].
 ! !

MuSAlbumView subclass: #MusAlbumAttachments
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

!MusAlbumAttachments methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 01:08'!
renderContentOn: html
html paragraph: 'Attachments:'.
	html mustache section 
		name:'attachmentsList';
		with:[
			html image
				url: '/albums/',(html mustache variable:'document') , 
					'/',
					(html mustache variable:'filename') ]. ! !

MuSTemplate subclass: #MuSAlbumsList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

MuSAlbumsList subclass: #MuSAlbumItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

!MuSAlbumItem methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 06:20'!
renderContentOn: html
html listItem:[
	html anchor 
		class:'album';
		id: (html mustache variable:'_id');
		url:('/albums/_design/musalbums/_show/album/' , (html mustache variable:'_id'));
		title: (html mustache variable:'_rev');
		with:[
			html heading level2;with:(html mustache variable:'artist').
		].
	html paragraph:(html mustache variable:'title').
	html paragraph:(html mustache variable:'description'). 
]! !

MuSAlbumsList subclass: #MuSAlbumsEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 10:46'!
renderAlbumSaveAttachmentOn:html
| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'at') assign:
	((GRSmallDictionary new) 
	at: 'url' put: 
		((JSStream on: '"/albums/"') call:'concat' 
				with: ((html jQuery:#id) value) 
		);
	at: 'success' put:(
					(( html jQuery:#eHeader) text:'Attachment added') asFunction,
					((JSStream on:'history')call:'back'))
	;yourself )
).

^
((	aScript,
	(html jQuery:#saveAttachmentForm) call:'ajaxSubmit' with: (JSStream on:'at')
	) condition:((html jQuery:#_attachments) value ))
! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 10:35'!
renderAlbumSaveScriptOn:html
| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: 'artist' put:((html jQuery:#artist) value);
	at: 'title' put:((html jQuery:#title) value);
	at: 'user' put:((html jQuery:#user) value);
	at: '_id' put:((html jQuery:#id) value);
	at: '_rev' put:((html jQuery:#rev) value);
	at: 'description' put:((html jQuery:#description) value);
	at: '_attachments' put:(JSStream on:'attachments');yourself)). 

html document addLoadScript:(
html jQuery document on:#pagebeforecreate selector:'#albumEditorPage' do:(
(html jQuery:#saveButton) onClick:(
aScript,
"remove id and rev property if they were nul and set our user"
(((JSStream on: 'doc') property:'_id') not 
			then: (JSStream on: 'delete doc._id')),
(((JSStream on: 'doc') property:'_rev') not 
			then: (JSStream on:'(doc.user= $("#dataStorage").data("log"))')),		
(((JSStream on: 'doc') property:'_rev') not 
			then: (JSStream on: 'delete doc._rev')),	
			
(html jQuery couch db:'albums';saveDoc: (JSStream on:'doc');
					onSuccess:(
								((html jQuery:#id) value:(JSStream on:'doc._id' )),
								((html jQuery:'input[name="_rev"], form') each:( 
										html jQuery this attributeAt:'value' put:(JSStream on:'doc._rev' ))) ,
								(self renderAlbumSaveAttachmentOn:html),
								(((html jQuery:#_attachments) value) not then: ((JSStream on:'history')call:'back'))
								);
					onError:(( html jQuery:#eHeader) text:'Error saving document'))
)))! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/11/2013 13:19'!
renderAlbumsListAddButtonOn:html

html document addLoadScript: (
html jQuery document on:#pagebeforecreate selector:'#home' do:(	
		((html jQuery:#buttonAdd) onClick:	(
		      ((html jQuery:#dataStorage) dataAt:#log) 
			then:
			 	(html jQuery mobile changePageUrl: '/albums/_design/musalbums/_show/album-add' options:nil )
			else:
				(html jQuery mobile changePageUrl: '/albums/_design/musalbums/_show/album-login' options:nil )))
		)
)	! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/11/2013 12:33'!
renderAlbumsListLinkEventsOn:html
"stores current doc id and rev in dataStorage"
html document addLoadScript: (
html jQuery document on:#pagebeforecreate selector:'#home' do:(	
			((html jQuery:'.album') onClick:(
										
										((html jQuery:#dataStorage) 
											dataAt:#currentDoc 
											put:	(html jQuery this attributeAt: 'id')),
										((html jQuery:#dataStorage) 
											dataAt:#currentRev 
											put:	(html jQuery this attributeAt: 'title'))
										)										
			)
	)
) ! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 06:10'!
renderAlbumsViewDeleteButtonOn:html

html document addLoadScript: (
	html jQuery document on:#pagebeforecreate selector:'#albumViewPage' do: (
		((html jQuery:#deleteButton) onClick:	(
		      ((html jQuery:#dataStorage) dataAt:#log) 
			then:
			 	(html jQuery mobile changePageUrl: '/albums/_design/musalbums/_show/album-delete' options:nil )
			else:
				(html jQuery mobile changePageUrl: '/albums/_design/musalbums/_show/album-login' options:nil )))
		)
)	! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 21:41'!
renderAlbumsViewEditButtonOn:html

html document addLoadScript: (
	html jQuery document on:#pagebeforecreate selector:'#albumViewPage' do: (
		((html jQuery:#editButton) onClick:	(
		      ((html jQuery:#dataStorage) dataAt:#log) 
			then:
			 	(html jQuery mobile changePageUrl: ((JSStream on:'"/albums/_design/musalbums/_show/album-add/"' ) call:'concat' with: ((html jQuery:#dataStorage) dataAt:#currentDoc)) options:nil )
			else:
				(html jQuery mobile changePageUrl: '/albums/_design/musalbums/_show/album-login' options:nil )))
		)
)	! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 09:30'!
renderAlbumsViewReloadOn:html

html document addLoadScript: (
	html jQuery document on:#pagebeforecreate selector:'#albumViewPage' do: (
		(html jQuery:#dataStorage) dataAt:#rev put:((html jQuery:#rev) value)
		)
)	! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/11/2013 15:31'!
renderAttachmentsDeleteOn:html
"register a delete attachment function on a click event for each element with the class .del (anchor in edit album) building an HTTP call:
DELETE /somedatabase/some_doc?rev=1582603387.
It must be registered after Mustache template is loaded"
html document addLoadScript: (
html jQuery document on:#pagebeforecreate selector:'#albumEditorPage' do:(	
((html jQuery:'.del') each:((html jQuery this) onClick:(
	((((((html jQuery this) previous)previous) attributeAt:'src') call:'toString') assignLocalTo: 'aUrl'),
	(((JSStream on:'aUrl') call:'concat' with: '?rev=' with:(((html jQuery:#rev) value) call:'toString' )) assignLocalTo:'aU'),
	(html jQuery ajax 
		url: (JSStream on:'aU');
		type:'delete';
		onSuccess: ((JSStream on:'history') call:'back')
							
))))))! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 12:15'!
renderContentOn: html
"all pages"
self renderPageHideOn:html.
"page #home"
self renderAlbumsListAddButtonOn:html.
self renderAlbumsListLinkEventsOn: html.
"page AlbumEditor"
self renderAttachmentsDeleteOn:html.
self renderAlbumSaveScriptOn:html.	
"page albumView"
self renderAlbumsViewDeleteButtonOn:html.
self renderAlbumsViewEditButtonOn:html.
self renderAlbumsViewReloadOn:html

! !

!MuSAlbumsEvents methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/12/2013 09:12'!
renderPageHideOn:html

html document addLoadScript:(
html jQuery document on:#pagehide selector:'div[data-role*="page"]' do:(		
		
		((html jQuery this children:'div[data-role*="content"]' ) is:'.command-no-cache') 
		then:(html jQuery this remove) 
	)
)! !

!MuSAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 19:50'!
initialize
super initialize.
self fullDocument:true.
! !

!MuSAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/10/2013 22:16'!
renderContentOn: html
html span id:#dataStorage.
html div 
	jqmPage; 
	id:#home;
	with:[
		html div
      	jqmHeader;
      	with: [
         		html heading level1;with: 'Albums'.
		].
	 html div
      	jqmContent;
		class:'command-no-cache';
      	with: [
			html unorderedList id:#albums;jqmListView;with:[
				html mustache section name:'albums';with:[
					(html mustache partial: 'MuSAlbumItem').
					]
			]
		].	
	html div
      	jqmFooter;
		jqmFixedPosition;	
      	with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor
								id:#buttonAdd;
								onClick:	((html jQuery:#dataStorage) 
											dataAt:#currentDoc put:nil 
										);
								with: 'Add Album' 
							
						]
				 ] 
			]
	]
 ].

html mustache partial:#MuSAlbumsEvents.
! !

!MuSAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/10/2013 12:25'!
updateRoot:anHtmlRoot
|ccsFiles libraries|
ccsFiles:= #(
    '/albums/_design/musalbums/javascript/jquery.mobile-1.3.0.css'
    '/albums/_design/musalbums/javascript/jquery.mobile.structure-1.3.0.css'
    '/albums/_design/musalbums/javascript/jquery.mobile.theme-1.3.0.css'
).
libraries:= #(
  '/albums/_design/musalbums/javascript/jquery-1.9.1.min.js'
  '/albums/_design/musalbums/javascript/jquery-migrate-1.1.1.js'
  '/albums/_design/musalbums/javascript/jquery.mobile-1.3.0.js'
  '/_utils/script/jquery.couch.js' 
  '/_utils/script/jquery.form.js'

).

ccsFiles do:	[:aLib|
	anHtmlRoot stylesheet  url:aLib].	
libraries do:	[:aLib|
	anHtmlRoot javascript url:aLib].
! !

MuSTemplate subclass: #MuSAlbumsLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

!MuSAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/2/2013 11:10'!
initialize
super initialize.
self fullDocument:true.! !

!MuSAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/2/2013 11:13'!
renderContentOn: html

html div 
	attributeAt:'data-role' put:'dialog'; 
	id:'albumLogin;';
	with:[
		html div
      	jqmHeader;
      	with: [
         		html heading
            	level1;
            	with:       [	html span:'CouchDB Status:'.
			html code id:#logger; with:'waiting for connection'].

		].
	 html div
      	jqmContent;
      	with: [
			html form with: [
				
  				html label for: #username;with: 'UserName:'.
				html textInput id: #username;name: #username.
   	  			html label for: #password;  with: 'Password:'.
   		   		html passwordInput id: #password;name:#password.
			].
		].	
	html div
      	jqmFooter;
		jqmFixedPosition;	
      	with: [
			html div
				jqmNavBar;
				id:#loginCtrl;
				with: [
					html unorderedList: [
						html listItem: [
							html anchor
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							onClick: (self renderLoginScriptOn:html);
							with: 'Submit' 
							] 
						] 
					]
			]
	]
 ! !

!MuSAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/9/2013 01:30'!
renderLoginScriptOn:js
"password is sended in plain text, don't do that in a real app otherwise use https or cipher the password"
^(js jQuery couch login:((js jQuery:'#username') value) password:((js jQuery:'#password') value) ;
				onSuccess:(
				(( js jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString), 
				(( js jQuery:#dataStorage) dataAt:'log' put: ((js jQuery:'#username') value) ),
				((JSStream on:'history') call:'back') );
				onError:((js jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString)) ! !

SCouchDBApp subclass: #MuSAlbumsApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile2'!

MuSAlbumsApplication class
	instanceVariableNames: 'aNewDoc db'!

MuSAlbumsApplication class
	instanceVariableNames: 'aNewDoc db'!

!MuSAlbumsApplication class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/25/2013 10:48'!
lesson1
"create our first database using the Smalltalk SCouchDB and add a document in our new database."
|  adaptor docArray|
aNewDoc:=JsonObject new.
aNewDoc 	at: 'artist' put:'Mark Knopfler';
		 	at:'album' put:'Get Lucky';
			at:'description' put:' sixth solo album released on 14 September 2009';
			at:'user' put:'jmari'.
adaptor:=SCouchDBAdaptor new 
       host: '127.0.0.1' 
       port: 5984 
       userName:'admin' 
       password:'admin'.
db:= adaptor ensureDatabase: 'albums'.
db documentPut: ( aNewDoc )


! !

!MuSAlbumsApplication class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/25/2013 12:21'!
lesson2
"adding new documents, handling _id and _rev "
|docArray|
aNewDoc 	at:'_id' put:'123456789A';
			at:'title' put:'Privatoring';
			at:'description' put:'seventh solo album by Mark Knopfler, released on 3 September 2012'.
db documentPut: ( aNewDoc ).
"we try to modify the title, it will rise an Exception"
aNewDoc 	at:'title' put:'Privateering'.
db documentPut: ( aNewDoc ).
"try again, now setting the document revision"
aNewDoc at:'_rev' put: (db documentCurrentRevAt:'123456789A').
db documentPut: ( aNewDoc ).

docArray:=db allDocuments.
docArray do:[:aDoc|
       Transcript show: aDoc asString.
]   


! !

!MuSAlbumsApplication class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/25/2013 10:48'!
lesson3
"adding new documents, handling _id and _rev"
aNewDoc 	at:'title' put:'Privatoring';
			at:'description' put:'seventh solo album by Mark Knopfler, released on 3 September 2012'.
db documentAt:'123456789A' put: ( aNewDoc ).
"we will update the document, because we made a mistake in the title"
aNewDoc 	at:'title' put:'Privateering'.
db documentAt:'123456789A' put: ( aNewDoc ).

! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEvently

self initEventlyFooters.
self initEventlyAlbumView.
self initEventlyAlbumDelete.
self initEventlyLoginDialog.
self initEventlyAlbumEdit.
self initEventlyAlbumAdd. 
self initEventlyAlbumSearch! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEventlyAlbumAdd

(self evently at:'albumAdd' )
		onEvent:'addCancel' do:
		'function( event ){
	   		$.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
    		}'; 
		onEvent:'addConfirm' do:
		'function(e){
		var document = {};
            document.artist = $("input#addArtistField").val();
            document.title = $("input#addTitleField").val();
            document.description = $("textarea#addDescriptionField").val();
            document.creation_date = ( new Date() ).getTime();
            $.albums.saveDocument( document, {
                    success: function() {
                           $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
                    },
                    error: function( status, error, reason ) {
                        alert( "Cannot save new document.\n" + status + ", " + reason + ", " + error );
                    }
              });
		}'.! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEventlyAlbumDelete

(self evently at:'albumDelete' )
		onEvent:'deleteCancel' do:'function( event ){
       		var docId = $("#deleteFooter").data("identity");
        		$.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
        		return false;
    		}'; 
		onEvent:'deleteConfirm' do:'function( event ){
	        var docId = $("#deleteFooter").data("identity");
	        // First open doc based on ID in order to get the  latest _revision.
	        $db.openDoc( docId, {
	            success: function( document ){
	                // Then use the opened doc as reference to remove.
	                $.albums.deleteDocument( document, {
	                    success:function(){
	                        $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
	                    },
	             	   error:function( status, error, reason ){
	                        alert( "Could not remove document with id: " + docId + "\n" + reason );
	                    }
	                });
	            },
	            error:function(){
	                alert( "Could not find document with id: " + docId );
	            }
	        });
	        return false;
	    }'! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEventlyAlbumEdit

(self evently at:'albumEdit' )
		onEvent:'editCancel' do:
		'function( event ){
        		var docId = $("#albumEditPage").data("identity");
        		$.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
    		}'; 
		onEvent:'editConfirm' do:
		'function(e){
			var currentAlbum= $$(this).currentAlbum;
			currentAlbum.artist = $("input#artistField").val();
			currentAlbum.title = $("input#titleField").val();
			currentAlbum.description = $("textarea#descriptionField").val();

			$.albums.saveDocument( currentAlbum, {	
				success: function( response )  {
					$.mobile.changePage( "/albums/_design/albums/_show/album/" + currentAlbum._id,"flip", true, true );
				},
				error: function( status, error, reason ) {
					alert( "Cannot save document: " + document._id + "\n" + reason );
				}
			});
		}';
		onEvent:'_init' 
		data:'function(e){
			var docId = $("#albumEditPage").data("identity");
			var currentAlbum;
			$db.openDoc( docId, {
					success: function( document ) {
						currentAlbum=document;
						
					},
					error: function() {
						alert( "Cannot open document: " + docId );
					}
				},
				{async:false});
			$$(this).currentAlbum = currentAlbum;			
			return  $$(this).currentAlbum;
		}'
		mustache:
		'<form id="albumform" action="#" method="get" >
  			<div data-role="fieldcontain"> 
	        	<label for="artist">Artist:</label> 
	   	    	<input id="artistField" name="artist" type="text" value="{{artist}}" />
			</div>
			<div data-role="fieldcontain"> 
	        	<label for="title">Title:</label> 
	   	    	<input id="titleField" name="title" type="text" value="{{title}}" />
			</div>
			<div data-role="fieldcontain"> 
				<label for="description">Description:</label> 
				<textarea id="descriptionField" name="description" cols="40" rows="8">{{description}}</textarea> 
			</div>
		</form>'! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEventlyAlbumSearch

(self evently at:'albumSearch' )
		onEvent:'searchCancel' do:
		'function( event ){
	   		$.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
    		}'; 
		onEvent:'searchConfirm' do:
		'function(e){
		var searchFieldContent = '''';
            searchFieldContent = $("input#searchField").val();
            $.mobile.changePage( "/albums/_design/albums/_list/albumSearch/albums?fieldContent=" + searchFieldContent, "slide", true, true );
		}'.! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEventlyAlbumView

(self evently at:'albumView') 
		onEvent:'albumDelete' do:'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-delete/" + docId, "slideup", false, false );
		}'; 
		onEvent:'albumEdit' do:
		'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-edit/" + docId, "flip", false, true )
		}';
		onEvent:'albumLet' do:	
			'function(e,data){
			var docId = $("#albumcontent").data("identity");
			// Change page.
			$.albums.letDocument(docId, {
				"success": function(){$.mobile.changePage( "/albums/_design/albums/_show/album-users/" + docId, "flip", false, true );}
			});
		}' ! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEventlyFooters

(self evently at:'albumFooter' onEvent:'_init')
	selector: '#deleteButton' 
	onClick:'function(){
			$(this).trigger(''albumDelete'');
			}';
	selector: '#editButton' 
	onClick:'function(){
			$(this).trigger(''albumEdit'');
			}';
	selector:'#letButton' 
	onClick:'function(){
			$(this).trigger(''albumLet'');
			}'. 
			
(self evently at:'deleteFooter' onEvent:'_init')
	selector: '#dialogCloseButton' 
	onClick:'function(){
			$(this).trigger(''deleteCancel'');
			}';	
	selector: '#deleteCancelButton' 
	onClick: 'function(){
			$(this).trigger(''deleteCancel'');
			}';
	selector: '#deleteConfirmButton' 
	onClick:'function(){
			$(this).trigger(''deleteConfirm'');
			}'. 



(self evently at:'editFooter' onEvent:'_init')
	selector: '#editCancelButton' 
	onClick:'function(){
			$(this).trigger(''editCancel'');
			}';	
	selector: '#editConfirmButton' 
	onClick:'function(){
			$(this).trigger(''editConfirm'');
			}'. 
			
		
(self evently at:'addFooter' onEvent:'_init')
	selector: '#addCancelButton' 
	onClick:'function(){
			$(this).trigger(''addCancel'');
			}';	
	selector: '#addConfirmButton' 
	onClick:'function(){
			$(this).trigger(''addConfirm'');
			}'. 
			
(self evently at:'searchFooter' onEvent:'_init')
	selector: '#searchCancelButton' 
	onClick:'function(){
			$(this).trigger(''searchCancel'');
			}';	
	selector: '#searchConfirmButton' 
	onClick:'function(){
			$(this).trigger(''searchConfirm'');
			}'. 
			
(self evently at:'loginCtrl' onEvent:'_init')
	selector: '#dialogCloseButton' 
	onClick:'function(){
			$(this).trigger(''loginCancel'');
			}';	
	selector: '#loginConfirmButton' 
	onClick:'function(){
			$(this).trigger(''loginConfirm'');
			}'. ! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initEventlyLoginDialog

(self evently at:'loginDialog' )
		onEvent:'loginCancel' do: 'function (e){$("#loginDialog").dialog(''close'');}';
		onEvent:'loginConfirm' do:
		'function(e,form){
			var username = $( "#username" ).attr(''value'');
  			var password = $( "#password" ).attr(''value'');
			//var uievent = ( ops.state == 0 ) ? "login" : "signup";
			$.albums.logIn(username,password);
			$(''#loginDialog'').dialog(''close'');
		}'! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initFilters
self addFilterAt:'mine'	
	put:
	[:doc :req|
		((doc user)= (req userCtx name)) 
	].
! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/7/2013 17:50'!
initLists
self addListAt:'albumIndex' put:
[:head :req|	
		
self provides:'html' with:[:aHead :aReq|
	|doc stash albums| 

	albums:=OrderedCollection new.
	[(doc:=self getRow ) isNil] whileFalse:[
		albums add: doc value.
		].

	stash :=JsonObject fromAssociations: {
		'albums'->(albums asArray).
	}.

	self send: (Mustache toHtml:MuSAlbumsList view:stash).
	]
].

! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/10/2013 13:11'!
initShows
self addShowAt: 'album-login' put: [:aDoc :req|
	Mustache toHtml:MuSAlbumsLogin view:aDoc.		
	].

self addShowAt: 'album' put: [:aDoc :req|
	|stash attachments|
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user'-> (aDoc at:'user').
		'document' -> (aDoc at:'_id')
	}.
	attachments:=OrderedCollection new.
	aDoc at:'_attachments' ifPresent:[:v|
		v keys do: [:k|
			attachments add: (JsonObject fromAssociations:{'filename' -> k}).
		]	
	].
	stash at:'attachmentsList' put:attachments asArray.
	
	Mustache toHtml: MuSAlbumView view:stash.		
	].

self addShowAt: 'album-add' put: [:aDoc :req|
	|stash attachments|
	aDoc 
		ifNil:[stash:=#()]
		ifNotNil:[
	stash:= aDoc.
	attachments:=OrderedCollection new.
	aDoc at:'_attachments' ifPresent:[:v|
		v keys do: [:k|
			attachments add: (JsonObject fromAssociations:{'filename' -> k}).
			]	
		
		].
	stash at:'attachmentsList' put:attachments asArray.
	"to include in jscript code"
	stash at:'renderedAttachments' put: (Json render:(aDoc at:'_attachments')).
	].

	Mustache toHtml:MuSAlbumEditor view:stash.		
	].

self addShowAt: 'album-delete' put: 
[:aDoc :req|
	Mustache toHtml:MuSAlbumDelete view:Array new.		
	].

"
done
self addShowAt: 'album-delete' put: 
[:aDoc :req|
	|stash|
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:MuSAlbumDelete view:stash.		
	].




self addShowAt: 'album-users' put: [:aDoc :req|
	| template adminUsers userCollection stash|
	
	adminUsers:=((req at:'secObj') at:'admins') at:'names'.
	userCollection:=OrderedCollection new.
	adminUsers do:[:anUserName|
		userCollection add: (
			JsonObject fromAssociations: {'userName'->anUserName})
		].

	
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'document' -> (aDoc at:'_id').
		'loans'->(aDoc at:'loans').
		'admins'->(userCollection asArray)
	}.
	template:=self templates at:'albumusers'.

	Mustache toHtml:template view:stash partials: self partials.		
	].

self addShowAt: 'album-add' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumadd'.
	Mustache toHtml:template view:stash partials: (self partials).		
	].

"
"
Depends on ObjectIndexer project
self addShowAt: 'album-search' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumsearch'.
	Mustache toHtml:template view:stash partials: (self partials).		
	]."! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initUpdateHandler
self addUpdateHandlerAt: 'setNewUser' put:[:aDoc :req|
	|template stash loans|
	
	loans:=aDoc at:'loans'.
	loans ifNil:[loans:=OrderedCollection new]
		  ifNotNil:[loans:=OrderedCollection newFrom:loans].
	loans add:(JsonObject fromAssociations:{
							'user' -> ( req query newuser).
							'date' -> (DateAndTime now asString).
							}).
	aDoc at:'loans'  put:loans.
	template:=self templates at:'album'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user' -> (aDoc at:'user').
		'document' -> (aDoc at:'_id').
	}.
	
	Array with:aDoc with:(Mustache toHtml:template view:stash partials: (self partials))
	].! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 16:43'!
initValidator


self validateDocUpdate: [:newDoc :savedDoc :userContext|
| isDeletingWithoutPermission isUpdatingWithoutPermission isAlbumUser|
	isDeletingWithoutPermission:=false.
	isUpdatingWithoutPermission:=false.
	isAlbumUser:=(self isAdmin or:[ self userIs:'albums-user']).

	(userContext at:'name' ) 
	ifNil:[ ((UnauthorizedException new) messageText:'You need to be logged in order to do that.') signal]
	ifNotNil:[
		(isAlbumUser) ifFalse:[((ForbiddenException new) messageText: 'You do not have proper access to edit this document.') signal]
		].
	isDeletingWithoutPermission:=((newDoc at:'_deleted') notNil) and:[ (savedDoc user = userContext name) not].
	isUpdatingWithoutPermission:=(newDoc user = userContext name) not or:[
		savedDoc 
			ifNil:[false] 
			ifNotNil:[
				(newDoc user = savedDoc user) not.
			]].

	((self isAdmin not) and:[isDeletingWithoutPermission] ) 
	ifTrue:[
		
		((ForbiddenException new ) messageText:'Only the creator of this document has permission to delete') signal
	] ifFalse:[
		((self isAdmin  not) and:[isUpdatingWithoutPermission and:[(newDoc at:'_deleted') isNil ]] )
		 ifTrue:[
				((ForbiddenException new) messageText: 'Only the creator of this document has permission to update') signal
				] 
		ifFalse:[
				((newDoc at:'_deleted') = true) 
				ifFalse:[	self required:'user']
			]	
	]
]
! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/25/2013 12:39'!
initViews.
self addViewAt:'albums'	
	put:
	[:doc|
		self emit: doc key:(doc at:'_id')
	].

"self addViewAt:'indexe'	
	put:
	[:doc|
		(self indexerAt:'album-index') indexeMessages:( doc keys) by:#id from:doc. 

	]."

	

self addViewAt:'recent-items'	
	put:
	[:doc|
		self emit: (doc at:'creation_date') key:(doc at:'creation_date')
	]
	reduce:'sum'.! !

!MuSAlbumsApplication methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/27/2013 19:06'!
initialize
super initialize.
self appName: 'musalbums'.
self language: 'smalltalk'.
self database: 'albums'.
self initViews.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\MuSAlbumsApplication\attachments\'.
self initLists.
self initShows.
"
self initEvently.
self initValidator.
self initUpdateHandler.
self initFilters.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\templates\'."
self connectTo:'localhost' port:5984 userName:'admin' password:'admin'.
self upload.


! !

WAComponent subclass: #JQAlbumDelete
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/12/2013 00:32'!
renderAlbumRemoveScriptOn:html
| aScript |

"we need the _revision"
aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: '_id' put:((html jQuery:#dataStorage) dataAt:#currentDoc);
	at: '_rev' put:((html jQuery:#dataStorage) dataAt:#currentRev);yourself
)). 
	
html document addLoadScript: 
((html jQuery:#deleteOkButton) onClick:(
(html jQuery couch db:'albums';removeDoc: aScript;
					onSuccess:(html jQuery mobile changePageUrl:  '/_seaside/albums' options:nil);
					onError:(( html jQuery:#fHeader) text:'Error deleting a Doc')
)))! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:08'!
renderContentOn:html
	self renderDeleteAlbumHeaderOn:html.
 	self renderDeleteAlbumContentOn:html.
   	self renderDeleteAlbumFooterOn:html.
	self renderAlbumRemoveScriptOn:html! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:08'!
renderDeleteAlbumContentOn:html
  html div
      jqmContent;
      with: [
	html heading level3 with:'Are you sure you want to remove this album?']
	! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:12'!
renderDeleteAlbumFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;	
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor
								jqmIcon: 'minus';
								id:#deleteOkButton;
								with: 'Ok' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							jqmIcon: 'gear';
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel'.
							] ] ].

] ! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:12'!
renderDeleteAlbumHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
		id:#fHeader;
            with: 'Delete Album']! !

!JQAlbumDelete methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 11:09'!
renderLoginHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
            with: 'Delete Album']! !

WAComponent subclass: #JQAlbumEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/11/2013 09:45'!
json
	^ JSJson new! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:32'!
loadSkeletonOn:html
	html div
      		jqmHeader;
      		with:  [	  
				   html heading
					id:#eHeader;
    			   	   level1;
      			   with:''.
				
				html anchor
           			 	class: 'ui-btn-right';
            			jqmIcon: 'home';
					url:'#pageId1';
            			with: 'Home' ].
	html div
			id:#eContent;
      		jqmContent;
      		with: ''.
	self renderAlbumEditorFooterOn:html.
	self renderAttachmentsOn:html! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:16'!
renderAlbumEditorContentOn:html


			html div jqmContainerTwoColumn; with: [
			html div jqmColumnOne; with: [
			html form id:#saveForm;post;with:[				
				self renderFormElementOn:html element:[
				html label
					for:#artist;
					with:'Artist:'.
				html textInput id:#artist;name:#artist;value:(html mustache variable:'artist').
				].
				self renderFormElementOn:html element:[
				html label
					for:#title;
					with:'Title:'.
				html textInput id:#title;name:#title;value:(html mustache variable:'title')].
				self renderFormElementOn:html element:[
				html label
					for:#description;
					with:'Description:'.
				html textInput id:#description;name:#description;value:(html mustache variable:'description')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#user;name:#user;value: (self session sessionData at:'name')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev')].
				self renderFormElementOn:html element:[
				html hiddenInput id:#id;name:#_id;value: (html mustache variable:'_id')].
				]
			].
			html div jqmColumnTwo; with: [
				html form id:#saveAttachmentForm;post;action:nil;multipart;with:[  
					html fileUpload id:#_attachments;name:#_attachments;multiple.  
					html hiddenInput id:#rev;name:#_rev;value: (html mustache variable:'_rev').
				].
				html div id:#attachmentsContent. 
			]
			
		]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:23'!
renderAlbumEditorFooterOn:html

html div
			id:#eFooter;
      		jqmFooter;
			jqmFixedPosition;
      		with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'back';
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlidedown
							 	id:#saveButton;
								jqmIcon: 'gear';
								with: 'save' ].		
					
			
			]
		]
	]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 16:57'!
renderAlbumEditorHeaderOn:html


      html html:(html mustache variable:'title').! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/14/2013 10:00'!
renderAlbumSaveAttachmentOn:html
| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'at') assign:
	((GRSmallDictionary new) 
	at: 'url' put: 
		((JSStream on: '"/albums/"') call:'concat' 
				with: ((html jQuery:#id) value) 
		);
	at: 'success' put:((( html jQuery:#eHeader) text:'Attachment added') asFunction);yourself )
).

^
((( html jQuery:#eHeader) text:'Attachment go')),
aScript,
	(((( html jQuery:#eHeader) text:'start trans')),
	((html jQuery:#saveAttachmentForm) call:'ajaxSubmit' with: (JSStream on:'at')),
	((( html jQuery:#eHeader) text:'end trans'))) condition:((html jQuery:#_attachments) value )! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:36'!
renderAlbumSaveScriptOn:html

| aScript |

aScript:=JSScript new.
aScript add: ((JSStream on: 'doc') assign:((GRSmallDictionary new) 
	at: 'artist' put:((html jQuery:#artist) value);
	at: 'title' put:((html jQuery:#title) value);
	at: 'user' put:((html jQuery:#user) value);
	at: '_id' put:((html jQuery:#id) value);
	at: '_rev' put:((html jQuery:#rev) value);
	at: 'description' put:((html jQuery:#description) value);
	at: '_attachments' put:(JSStream on:'attachments');yourself)). 

html document addLoadScript: (
(html jQuery:#saveButton) onClick:(
aScript,
"remove id and rev property if they were nul"
(((JSStream on: 'doc') property:'_id') not then: (JSStream on: 'delete doc._id')),
(((JSStream on: 'doc') property:'_rev') not then: (JSStream on: 'delete doc._rev')),
(html jQuery couch db:'albums';saveDoc: (JSStream on:'doc');
					onSuccess:(
								((html jQuery:'input[name="_rev"], form') each:( 
										html jQuery new value:(JSStream on:'doc._rev' ))) ,
								(( html jQuery:#eHeader) text:'Document saved'),
								(self renderAlbumSaveAttachmentOn:html),
								((JSStream on:'history')call:'back'));
					onError:(( html jQuery:#eHeader) text:'Error saving document'))
)
)! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:16'!
renderAlbumViewLoadScriptOn:html
"Loads a doc from CouchDb and renders Mustache templates"
html document addLoadScript:(
(html jQuery page onShow:(
   	html jQuery couch db:'albums';openDoc:((html jQuery:#dataStorage) 
											dataAt:#currentDoc);
					onSuccess:(
						"attachments global var stores temporally the doc attachments
						we need them to save them back"
						(((html jQuery event)access:'_attachments') assignTo:'attachments' ),
						(( html jQuery:#eContent) 
							mustache: (html jQuery:#aeContent) html
							data:(html jQuery event);
							trigger: 'create') ,
						(( html jQuery:#eHeader) 
							mustache: (html jQuery:#aeHeader) html
							data:html jQuery event
							command:'text'),
						"attachments are javascript dictionaries indexed by a filename, Mustache can not handle this kind of structure, it handles objects with well-know properties or arrays of objects "
						(( html jQuery:#attachmentsContent) 
							mustache: (html jQuery:#tAttachments) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)));
							trigger:'create')),
						(self renderAttachmentsDeleteOn: html);
					onError:(
						(( html jQuery:#eContent) 
							mustache: (html jQuery:#aeContent) html
							data:(html jQuery event);
							trigger: 'create') ,
						(( html jQuery:#eHeader) 
							text:'New Album'))
	))
)! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:21'!
renderAttachmentsDeleteOn:html
"register a delete attachment function on a click event for each element with the class .del (anchor in edit album) building an HTTP call:
DELETE /somedatabase/some_doc?rev=1582603387.
It must be registered after Mustache template is loaded"
^
(((html jQuery:'.del') each:((html jQuery new) onClick:(
					((((((html jQuery this) previous)previous) attributeAt:'src') call:'toString') assignLocalTo: 'aUrl'),
					(((JSStream on:'aUrl') call:'concat' with: '?rev=' with:(((html jQuery:#rev) value) call:'toString' )) assignLocalTo:'aU'),
					(html jQuery ajax 
							url: (JSStream on:'aU');
							type:'delete';
							onSuccess: ((JSStream on:'history') call:'back')
							
					)))))
			
	
! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 18:45'!
renderAttachmentsOn:html
html mustache template:'tAttachments';with:[
	html paragraph: 'Attachments:'.
	html mustache section 
		name:'_attachments';
		with:[
			html image class:'img';
				url: '/albums/',(html mustache variable:'_id') , 
					'/',
					(html mustache variable:'filename'). 
			html break.
			html anchor jqmButton;class:'del';
			with:'remove'.	
					
		]. 
	
]! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 18:38'!
renderContentOn:html
self renderAlbumViewLoadScriptOn:html.	
self renderAlbumSaveScriptOn:html.
self renderAlbumSaveAttachmentOn:html.
self loadSkeletonOn:html.
html mustache template:'aeHeader';
	with:[self renderAlbumEditorHeaderOn:html].
html mustache template:'aeContent';
	with:[self renderAlbumEditorContentOn:html].
html mustache template:'aeFooter';
	with:[self renderAlbumEditorFooterOn:html].



! !

!JQAlbumEditor methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 16:59'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

WAComponent subclass: #JQAlbumView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/4/2013 00:05'!
json
	^ JSJson new! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:22'!
loadSkeletonOn:html
"renders a mobile skeleton(the static content) page"
	html div
      		jqmHeader;
      		with:  [	  
				   html heading
					id:#bHeader;
    			   	   level1.
      			   "with:....will be filled by mustache"
				
				html anchor
           			 	class: 'ui-btn-right';
            			jqmIcon: 'home';
					jqmTransitionSlide; 
					url:'#pageId1';
            			with: 'Home' ].
	html div
			id:#bContent;
      		jqmContent.
		 	"with:....will be filled by mustache"
		
	self renderAlbumViewFooterOn:html.
	self renderAttachmentsOn:html! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:48'!
renderAlbumViewContentOn:html
"it is loaded as a mustache template"
		html div jqmContainerTwoColumn; with: [
			html div jqmColumnOne; with: [
				html heading
            			level1;
            			with:(html mustache variable:'artist').
				html paragraph:(html mustache variable:'title').
				html paragraph:(html mustache variable:'description').
				html paragraph:(html mustache variable:'user')].
			html div jqmColumnTwo; with: [
				html div id:#bAttachmentsContent.
				"with:...will be filled later by mustache"
									]
								
		]		
		
		! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:23'!
renderAlbumViewFooterOn:html

html div
			id:#dFooter;
      		jqmFooter;
			jqmFixedPosition;
      		with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'minus';
								jqmDialog;
								jqmTransitionFlip;
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumDelete new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Delete' ].
						html listItem: [
							html anchor jqmTransitionSlidedown
							 	id:#editButton;
								jqmIcon: 'gear';
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumEditor new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Edit' ].						
					] 
			]
]! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:42'!
renderAlbumViewHeaderOn:html
"this template only updates the text content of the html heading. We don't want to replace other tags because we want to preserve mobile classes"

      html html:(html mustache variable:'title').

	! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:47'!
renderAlbumViewLoadScriptOn:html
"loads an album document and fill the empty skeleton with mustache templates"
html document addLoadScript:(
html jQuery page onShow:(
   	html jQuery couch db:'albums';openDoc:((html jQuery:#dataStorage) 
											dataAt:#currentDoc);
					onSuccess:(
						(( html jQuery:#bContent) 
							mustache: (html jQuery:#avContent) html
							data:html jQuery event) ,
						(( html jQuery:#bHeader) 
							mustache: (html jQuery:#avHeader) html
							data:html jQuery event
							command:'text'),
						"Couchdb attachments need a transformation from jsscript dictionary 
						to an array of pair index->value, in order to be rendered in a mustache template
						attachmentsToArray is defined within development lib and is not present 
						if you don't use this lib"
						(( html jQuery:#bAttachmentsContent) 
							mustache: (html jQuery:#avAttachments) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)))));
					onError:((html jQuery:#aView)  html:'Error in connection')
		 
		)
	)
	! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:45'!
renderAttachmentsOn:html
html mustache template:'avAttachments';with:[
	html paragraph: 'Attachments:'.
	html mustache section 
		name:'_attachments';
		with:[
			html image
				url: '/albums/',(html mustache variable:'_id') , 
					'/',
					(html mustache variable:'filename') ]. 
	
]! !

!JQAlbumView methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:34'!
renderContentOn:html
self renderAlbumViewLoadScriptOn:html.	
self loadSkeletonOn:html.
"render mustache templates"
html mustache template:'avHeader';
	with:[self renderAlbumViewHeaderOn:html].
html mustache template:'avContent';
	with:[self renderAlbumViewContentOn:html].
html mustache template:'avFooter';
	with:[self renderAlbumViewFooterOn:html].

	! !

WAComponent subclass: #JQAlbumsList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumsList class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/6/2013 23:00'!
canBeRoot
^true! !

!JQAlbumsList class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:28'!
register
JQMAdmin register: self asApplicationAt: 'albums'! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/6/2013 17:50'!
json
	^ JSJson new! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 12:21'!
renderAlbumListContentOn:html

		html div
      		jqmContent;
      		with: [	
				html unorderedList 
					id:#listContent;
      				jqmListView.
      				
			].
		
html mustache 
		template:#al;
		with:[		
			html mustache 
				section name:'rows';
				with:[  
           			html listItem
					with: [
      				html anchor
						id: (html mustache variable:'id');
						title: (html mustache variable:'value._rev');
						jqmTransitionSlide; 
						callback:[self show:JQAlbumView new];
           					with: [
							html mustache section 
								name:'_attachments';
								with:[
									html image
						 				url: '/albums/',(html mustache variable:'_id') , 
										'/',
										(html mustache variable:'filename') ].
							html heading level1; with:(html mustache variable:'value.artist').
							html paragraph: (html mustache variable:'value.description').   
							html paragraph: (html mustache variable:'value.title').   
                      			]  .
 	      			
  		      
		] ] ].

! !

!JQAlbumsList methodsFor: 'accessing' stamp: 'JesusMari 2/12/2013 00:51'!
renderAlbumListFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor jqmTransitionSlidedown
								jqmIcon: 'plus';
								onClick:	((html jQuery:#dataStorage) 
											dataAt:#currentDoc 
											put:	nil);
								callback: [
									self session loggedIn 
										ifTrue:[self show:JQAlbumEditor new]
										ifFalse:[self show: JQAlbumsLogin new].
									];
								with: 'Add' ].
						html listItem: [
							html anchor jqmTransitionSlidedown	
								jqmIcon:'search';
								with: 'Search' 
							] 
					] 
			]
	] ! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/15/2013 22:31'!
renderAlbumListHeaderOn:html
html div
	id:#dataStorage;
      jqmHeader;
      with: [
         html heading
            level1;
            with:       [	html span:'Albums'].
	 ].
! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/14/2013 18:15'!
renderAlbumListLoadScriptOn:html
"we have to declare the event callback after the list  was updated and before it was refreshed because jQuery mobile will wrap our anchor tag with a Div tag and the jquery sentence had to be div > a loosing sense"
html document addLoadScript:(
html jQuery page onShow:(
   	html jQuery couch db:'albums';view:'albums/albums';
					onSuccess:(( html jQuery:#listContent) 
							mustache: (html jQuery:#al) html
							data:((JSStream on:'attachmentsToArray') apply: (Array with:( html jQuery event)))
							command:'html'),
							((html jQuery:'li > a') onClick:(
										((html jQuery:#dataStorage) 
											dataAt:#currentDoc 
											put:	(html jQuery this attributeAt: 'id')),
										((html jQuery:#dataStorage) 
											dataAt:#currentRev 
											put:	(html jQuery this attributeAt: 'title')))),
							((html jQuery:#listContent) jqmListView refresh);
					onError:((html jQuery:#alist) html:'Error in connection')
		 
		)
)	! !

!JQAlbumsList methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:22'!
renderContentOn:html

	self renderAlbumListHeaderOn:html.
	self renderAlbumListContentOn:html.
	self renderAlbumListFooterOn:html.
	self renderAlbumListLoadScriptOn:html.
	
	! !

WAComponent subclass: #JQAlbumsLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/12/2013 02:26'!
initialize
super initialize.

! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:22'!
json
	^ JSJson new
! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 21:32'!
renderContentOn:html
	self renderLoginHeaderOn:html.
 	self renderLoginContentOn:html.
   	self renderLoginFooterOn:html! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 11:03'!
renderFormElementOn: html element: elementBlock
	html div
		jqmFieldContainer;
		with: [
			elementBlock value ]! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 19:05'!
renderLoginContentOn:html
  html div
      jqmContent;
      with: [
	html form: [
  
		self renderFormElementOn:html element: [
			html label
				for: #uName;
				with: 'UserName:'.
			html textInput
				id: #uName.
		].
	
		self renderFormElementOn:html element: [
     			 html label
         			for: #passw;
         			with: 'Password:'.
      		html passwordInput
         			id: #passw.
		].
	].	
].
 ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 19:20'!
renderLoginFooterOn:html
html div
      jqmFooter;
	jqmFixedPosition;	
      with: [
		html div
			jqmNavBar;
			with: [
					html unorderedList: [
						html listItem: [
							html anchor
								onClick:((JSStream on:'history') call:'back');
								with: 'Cancel' ].
						html listItem: [
							html anchor jqmTransitionSlide	
							onClick: (html jQuery ajax script:[:s | s<<(self renderLoginScriptOn:s)]);
							with: 'Submit' 
							] ] ].

] ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 11:21'!
renderLoginHeaderOn:html
html div
      jqmHeader;
      with: [
         html heading
            level1;
            with:       [	html span:'CouchDB Status:'.
		html code id:#logger; with:'waiting for connection']].
   ! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:27'!
renderLoginScriptOn:js
"password is sended in plain text, don't do that in a real app otherwise use https or cipher the password"
^(js jQuery couch login:((js jQuery:'#uName') value) password:((js jQuery:'#passw') value) ;
				onSuccess:(( js jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString),
							(js jQuery ajax callback:[:v|
								self session sessionData:(JSJsonParser parse: v)
								]
								value:(self json stringify:js jQuery event)),
								((JSStream on:'history') call:'back');
				onError:((js jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString)) 
! !

!JQAlbumsLogin methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:27'!
updateRoot:anHtmlRoot
"always as a dialog box"
anHtmlRoot pageDivAttributes at: 'data-role' put: 'dialog'! !

WAComponent subclass: #JQSCouchDBTest
	instanceVariableNames: 'textInput aCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional'!

!JQSCouchDBTest class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:12'!
canBeRoot
^true! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/1/2013 13:11'!
json
	^ JSJson new! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 20:23'!
renderContentOn:html
"self requestContext response headers at:'Access-Control-Allow-Origin' put:'"
html heading:'Demo CouchDB'.
self renderCouchInitOn:html.
self renderDocOn:html.
self renderTemplateOn:html! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 08:23'!
renderCouchInitOn:html
	html div with:[
		html span:'Status:'.
		html code id:#logger; with:'waiting for connection'.
		].
	html script:(
		html jQuery ready:(
			"don't do that in a real app"
			html jQuery couch login:'admin' password:'admin' ;
				onSuccess:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Logged-in at ', DateAndTime now asString]);
				onError:( 
					html jQuery ajax script:[:s|s << (s jQuery:#logger) html: 'Error in connection at  ', DateAndTime now asString]))
		)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 11:00'!
renderCouchLoadViewOn:js 
"Server side style"
	^ js jQuery couch db:'test';allDocs;
		onSuccess: 
					((js jQuery:#serverSide) load 
							html:[:html|
								html paragraph:( aCollection at:'total_rows').
								aCollection
								ifNil:[html paragraph]
								 ifNotNil:[
									(aCollection at:'rows' ) do:[:i|
										 html paragraph:(i at:#id). 
									].
								]
							];
					callback:[:data|
						aCollection:= JSJsonParser parse: data.
						]	 
					value: (self json stringify: js jQuery event))! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 13:56'!
renderCouchLoadViewOnNew:js 
"client side style- using a mustache template rendered on client side"
	^ js jQuery couch db:'test';allDocs;
		onSuccess: 
					((js jQuery:#clientSide)  
							mustache: (js jQuery:#test1) html
							data:(js jQuery event)
							partials: 
							(GRSmallDictionary new
								at: 'part1'
								put: (js jQuery:#part1) html;
								yourself)
							command:'html'
					)! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:54'!
renderCouchSaveDocOn:js content:aWord

	js << js jQuery couch db:'test';saveDoc: (JSStream on:'{"word":"', aWord,'"}');
				onSuccess: (
							(self renderCouchLoadViewOnNew: js),
							(self renderCouchLoadViewOn: js)
						).
	
	
		! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 10:57'!
renderDocOn:html
 self
      renderLabel: 'Text-Input'
      control: [ :id :script |
         html textInput
            id: id;
            value: textInput;
            callback: [ :value | textInput := value ];
            onChange: (script html: [ :h | h render: textInput ]).
         "the following code checks if a manual submit does a correct encoding:"
         html submitButton
            onClick: (html jQuery ajax
               callback: [ :value | textInput := value ] 
		   value: (html jQuery id: id) value;
               script: [ :s | 
				self renderCouchSaveDocOn: s content: textInput.
				]);
            with: 'Manual Submit'.
  	 ]
      model: textInput
      on: html.

	html table id:#dataList; with:[
		html tableData with:[
			html paragraph id:#clientSide
			].
		html tableData with:[
			html paragraph id:#serverSide 
	] 
].

! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/11/2012 18:06'!
renderLabel: aString control: aBlock model: anObject on: html
   | id |
   html fieldSet: [
      html label
         for: (id := html nextId);
         with: aString.
      html span: [
         aBlock
            value: id
            " update the paragraph "
            value: ((html jQuery this	
               parents: 'fieldset';
               find: 'p') load
                  " serialize all nearby form elements "
                  serialize: (html jQuery this		
                     parents: 'span';
                     find: ':input')) ].
      html paragraph: anObject ]
! !

!JQSCouchDBTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/22/2013 20:06'!
renderTemplateOn:html
html mustache
		template:'test1';
		with:[
			html paragraph:( html mustache variable:'total_rows').
			
				html mustache section 
						name:'rows';
						with: [(html mustache partial: 'part1')]
			].
html mustache
		template:'part1';
		with:[
		 html paragraph:(html mustache variable:'id')
		]! !

WASession subclass: #JQAlbumsSession
	instanceVariableNames: 'sessionData currentDoc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests-Functional-mobile'!

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 16:21'!
currentDoc
^ currentDoc
! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 15:50'!
currentDoc: docId
currentDoc:=docId
! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:32'!
initialize
super initialize.
sessionData:=nil! !

!JQAlbumsSession methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 18:37'!
loggedIn
^self  sessionData notNil.! !

!JQAlbumsSession methodsFor: 'accessing' stamp: 'JesusMari 2/8/2013 18:28'!
sessionData
	^ sessionData! !

!JQAlbumsSession methodsFor: 'accessing' stamp: 'JesusMari 2/8/2013 18:28'!
sessionData: anObject
	sessionData := anObject! !

JSObjectTest subclass: #JQueryCouchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests'!

JQueryCouchTest subclass: #JQueryCouchDbTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Tests'!

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/30/2012 23:16'!
couch
	^ self jQuery couch! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 00:13'!
couchDb
	^ self jQuery couchDb! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/13/2013 00:30'!
test0Couch
	self
		assert: (self jQuery couch)
		equals: self function , '.couch'.
self
		assert: (self jQuery couch urlPrefix:'http://localhost:5984')
		equals: self function , '.couch.urlPrefix="http://localhost:5984"'.
		
	self
		assert: (self jQuery couch urlPrefix)
		equals: self function , '.couch.urlPrefix'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:58'!
test0Database

	self
		assert: (self jQuery couch db:'test';create)
		equals: self function , '.couch.db("test").create'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/13/2013 00:45'!
test0EncodeDocId

	self
		assert: (self jQuery couch encodeDocId:'test')
		equals: self function , '.couch.encodeDocId("test")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:58'!
test1Info

	self
		assert: (self jQuery couch info;onSuccess:'alert(data);')
		equals: self function , '.couch.info({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:04'!
test2allDbs

	self
		assert: (self jQuery couch allDbs)
		equals: self function , '.couch.allDbs'.
	self
		assert: (self jQuery couch allDbs;onSuccess:'alert(data);')
		equals: self function , '.couch.allDbs({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test3SignUp
|user|

	
	self
		assert: (self jQuery couch signUp:'bob' password:'superpassword')
		equals: self function , '.couch.signup({"_id":"org.couchdb.user:bob","name":"bob"},"superpassword")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test4Login


	
	self
		assert: (self jQuery couch login:'bob' password:'superpassword';onSuccess:'done')
		equals: self function , '.couch.login({"success":function(data){done},"password":"superpassword","name":"bob"})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test5session

	self
		assert: (self jQuery couch session;onSuccess:'alert(data);')
		equals: self function , '.couch.session({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test6logout

	self
		assert: (self jQuery couch logout;onSuccess:'alert(data);')
		equals: self function , '.couch.logout({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test7activeTasks

	self
		assert: (self jQuery couch activeTasks;onSuccess:'alert(data);')
		equals: self function , '.couch.activeTasks({"success":function(data){alert(data);}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test8config

	self
		assert: (self jQuery couch config:'uuids'option:'algorithm';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm")'.
	self
		assert: (self jQuery couch config:'uuids'option:'algorithm'value:'sequential';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm","sequential")'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
test9userDb

	self
		assert: (self jQuery couch userDb:'alert(data);')
		equals: self function , '.couch.userDb(function(data){alert(data);})'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
testAnewUUID

	self
		assert: (self jQuery couch newUUID)
		equals: self function , '.couch.newUUID()'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 17:59'!
testBReplicateDatabase

	self
		assert: (self jQuery couch replicate:'DB' to:'NEWDB' createTarget:true;onSuccess:'done';onError:'error')
		equals: self function , '.couch.replicate("DB","NEWDB",{"success":function(data){done},"error":function(status){error}},{"create_target":true})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testCDatabaseCreate

	self
		assert: (self jQuery couch db:'test';create;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").create({"success":function(data){done},"error":function(status){error}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testDDatabaseInfo

	self
		assert: (self jQuery couch db:'test';info;onSuccess:'done')
		equals: self function , '.couch.db("test").info({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/10/2013 21:52'!
testEsaveDoc

	self
		assert: (self jQuery couch db:'test';saveDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").saveDoc("aDoc",{"success":function(data){done},"error":function(status){error}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testFopenDoc

	self
		assert: (self jQuery couch db:'test';openDoc:'d12ee5ea1df6baa2b06451f44a019ab9';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").openDoc("d12ee5ea1df6baa2b06451f44a019ab9",{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testGremoveDoc

	self
		assert: (self jQuery couch db:'test';removeDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").removeDoc("aDoc",{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:49'!
testHbulkSave

|aDoc|
	aDoc:=GRSmallDictionary new.
	aDoc at:'docs' put: 'aDocument'.
	
	self
		assert: (self jQuery couch db:'test';bulkSave:(aDoc);onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkSave({"docs":"aDocument"},{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:51'!
testIbulkRemove

|aDoc|
	aDoc:=GRSmallDictionary new.
	aDoc at:'docs' put: 'aDocument'.
	self
		assert: (self jQuery couch db:'test';bulkRemove:aDoc;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkRemove({"docs":"aDocument"},{"success":function(data){done},"error":function(status){error}})'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testJallDocs

	self
		assert: (self jQuery couch db:'test';allDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDocs({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:00'!
testKallDesignDocs

	self
		assert: (self jQuery couch db:'test';allDesignDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDesignDocs({"success":function(data){done}})'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testKquery

	self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}})'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}})'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testLallApps

	self
		assert: (self jQuery couch db:'test';allApps;forEachApp:('console.log(appName+" "+appPath+" "+ddoc');onSuccess:'done')
		equals: self function , '.couch.db("test").allApps({"success":function(data){done},"eachApp":function(appName,appPath,ddoc){console.log(appName+" "+appPath+" "+ddoc}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testMquery

self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}})'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}})'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}})'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testOview

	self
		assert: (self jQuery couch db:'test';view:('default/all');onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").view("default/all",{"reduce":false,"success":function(data){done},"error":function(status){err}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testPlist

	self
		assert: (self jQuery couch db:'test';list:('default/all') with:'all';onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").list("default/all","all",{"reduce":false,"success":function(data){done},"error":function(status){err}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testQcompact

	self
		assert: (self jQuery couch db:'test';compact;onSuccess:'done')
		equals: self function , '.couch.db("test").compact({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:01'!
testRviewCleanup

	self
		assert: (self jQuery couch db:'test';viewCleanup;onSuccess:'done')
		equals: self function , '.couch.db("test").viewCleanup({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testScompactView

	self
		assert: (self jQuery couch db:'test';compactView:'default';onSuccess:'done')
		equals: self function , '.couch.db("test").compactView("default",{"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testTchange

	self
		assert: (self jQuery couch db:'test';onChange:'done')
		equals: self function , '.couch.db("test").changes().onChange(function(data){done})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testUdrop

	self
		assert: (self jQuery couch db:'test';drop;onSuccess:'done')
		equals: self function , '.couch.db("test").drop({"success":function(data){done}})'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/9/2013 18:02'!
testVcopyDoc

	self
		assert: (self jQuery couch db:'test';copyDoc:'11111';onSuccess:'done';onError:'err';beforeSend:'send')
		equals: self function , '.couch.db("test").copyDoc("11111",{"success":function(data){done},"error":function(status){err}},{"beforeSend":function(xhr){send}})'.
		
	! !

!JQueryCouchTest class methodsFor: 'testing' stamp: 'JesusMari 3/30/2012 23:13'!
isAbstract
	^ self name = #JQueryTest! !

!JQueryCouchTest class methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
packageNamesUnderTest
	^ #('JQuery-Core')! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
function
	"Answers the name of the jQuery function. This can be either '$' or 'jQuery' or any other user chosen name. This makes sure the tests run in any case."

	^ JQuery functionName! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery
	^ JQueryClass context: self renderContext! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery: anObject
	^ self jQuery with: anObject! !
